TYPO3.Flow - Task # 1843

Status: Resolved Priority: Must have
Author: Karsten Dambekalns Category: Cache
Created: 2008-10-27 Assigned To:

Updated: 2010-10-20 Due date:

Sprint:

PHP Version:

Has patch:

Complexity:

Subject: Check file cache backend

Description

Make sure it does all it needs to do and does it well.

Associated revisions

Revision ef993404 - 2008-10-28 16:46 - Karsten Dambekalns
FLOWS:
- some cleanup in Cache component, refs #1843, refs #1844
- added findByTag() to cache frontends, fixes #1199

Revision adde6ecc - 2009-01-15 15:24 - Robert Lemke

This is a big commit (sorry - not exactly Continuous Integration ...)
While all seems to be fine and stable, many features introduced in this commit are not complete. Especially AOP Proxy Caching, Logging (API), the
System Logger and the Signal Slots mechanism need some further work.

- TYPOS3 Distribution: Added a Log directory

- TYPOS3 Distribution: Disabled security (for now) because some thing need to be refactored and tested again after this commit

- FLOWS: Further cleanup of the bootstrap. Addresses #2117

- FLOWS3: Removed manual registration of objects from all classes and created an Objects.yaml configuration instead which declares the objects
and configures their dependencies. This manual registration is necessary for objects such as the AOP Framework because at the time it is created, the
Object Manager is not yet fully initialized.

- FLOWS: (AOP) Refactored and cleaned up the AOP initialization process. Resolves #441.

- FLOWS: (AOP) Completely rewrote all unit tests and added many new ones. Now no AOP test relies on the TestPackage anymore. Addresses
#1868

- FLOWS: (AOP) Improved the automatic documentation rendering of the Proxy Class Builder. Resolves #35.

- FLOWS: (AOP) Externalized the creation of the AOP proxy and instead use the Caches.yaml configuration.

- FLOWS: (AOP) Removed all use of PHP's Reflection classes and replaced them with calls to the Reflection Service

- FLOWS: (AOP) Converted all classes involved in the proxy building process from static into dynamic calls

- FLOWS: (Cache) Introduced an (semi) automatic cache registration feature which assures that all necessary caches are registered when file
changes are detected. In order to register a cache, just define it in the new "Caches.yaml|" configuration file. See the FLOW3 package for examples.
Resolves #1787

- FLOWS: (Cache) Wrote more tests for the File Backend. Resolves #1843

- FLOWS: (Configuration) Improved the performance of the special configuration management

- FLOWS: (Configuration) Added support for Caches.* configuration

- FLOWS: (Error) The exception handlers now log uncaught exceptions to the System Logger

- FLOWS: (Monitor) Introduced a new sub package "Monitor" which provides a mechanism for automatic detection of changes on monitored files. If
monitored files or directories (the latter not yet implemented) change, a signal is emitted which can be catched by a slot taking further action. Currently
all cache entries tagged with a class tag are flushed automatically if a class file changes.
- FLOWS: (Log) Introduced a special System Logger which is created automatically and can be injected if needed. Although it works quite well
already, the general concept of injecting the logger and the Loggerinterface itself is not final! Watch for log files in the Data/Log/ directory when running
TYPO3 / FLOWS in development context.

- FLOWS: (Log) Introduced a Logger Factory for use in Objects configuration. Warning: the API might still change

- FLOWS: (Log) Made the SEVERITY constants conform to RFC3164 and PHP's LOG_* constants

- FLOWS: (Object) Refactored and detached more unit tests from the TestPackage. Addresses #2123

- FLOWS: (Object) Implemented an early configuration parse step which allows for configuring objects in the Objects.yaml file of the FLOW3
package even before the Package Manager is initialized.

- FLOWS: (Object) Introduced a lifecycle shutdown method (default is "shutdownObject") which can be used as a clean alternative to __destructy().

- FLOWS: (Reflection) Added new API methods: isClassReflected, getinterfaceNamesImplementedByClass, isMethodFinal, isMethodStatic,
isMethodPublic, isMethodProtected, isMethodPrivate

- FLOWS: (Reflection) getMethods() now returns information about the method visibility

- FLOWS: (Security) Refactored the ACL Policy Service - might still need some final work

- FLOWS: (SignalSlot) Fixed some small issues in the Dispatcher and implemented support for System Logger

- FLOWS: (Utility) Fixed a bug in Arrays::getValueByPath

- Testing: Implemented a method buildAccessibleProxy() in the BaseTestCase which allows for conveniently calling protected methods of a class.
See FLOWS unit tests for examples.

- TestPackage: Removed many classes which became obsolete due to the AOP tests refactoring. refs #1868

Revision e15182c¢5 - 2009-01-27 14:29 - Karsten Dambekalns

FLOWS (Cache):
- removed wildcard support (from documentation) in getByTag() and findldentifierByTag()
- moved some methods, constants and checks to better-fitting places

fixes #1844, refs #1843

Revision 661fe747 - 2009-01-27 17:32 - Karsten Dambekalns
FLOW3 (Cache):
- added setter for default lifetime to AbstractBackend
- fixed handling of unlimited default lifetime in all three backend implementations (refs #1843, refs #1844)

- the default cache configuration (Caches.yaml) now sets unlimited expiry time, should help against exception 1229362833

History

#1 - 2008-10-27 17:57 - Karsten Dambekalns
- Tracker changed from Bug to Task

#2 - 2008-10-28 12:58 - Karsten Dambekalns

- Priority changed from Should have to Must have
- Target version set to 1.0 alpha 1

#3 - 2009-01-15 15:25 - Robert Lemke

- Status changed from New to Resolved
- % Done changed from 0 to 100

Applied in changeset r1747.
